=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2007-02-14 06:20:34 +0000
+++ bzrlib/dirstate.py	2007-02-14 06:48:14 +0000
@@ -202,15 +202,21 @@
             # child
             raise errors.NotVersionedError(path, str(self))
         block = self._dirblocks[block_index][1]
+        if stat is None:
+            size = 0
+            packed_stat = DirState.NULLSTAT
+        else:
+            size = stat.st_size
+            packed_stat = pack_stat(stat)
         if kind == 'file':
             row_data = ((dirname, basename, kind, file_id.encode('utf8'),
-                stat.st_size, pack_stat(stat), link_or_sha1), [])
+                size, packed_stat, link_or_sha1), [])
         elif kind == 'directory':
             row_data = ((dirname, basename, kind, file_id.encode('utf8'),
-                0, pack_stat(stat), ''), [])
+                0, packed_stat, ''), [])
         elif kind == 'symlink':
             row_data = ((dirname, basename, kind, file_id.encode('utf8'),
-                stat.st_size, pack_stat(stat), link_or_sha1), [])
+                size, packed_stat, link_or_sha1), [])
         else:
             raise errors.BzrError('unknown kind %r' % kind)
         row_index = bisect.bisect_left(block, row_data)

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2007-02-14 06:25:37 +0000
+++ bzrlib/workingtree_4.py	2007-02-14 06:48:14 +0000
@@ -170,9 +170,10 @@
             assert '..' not in f
             if file_id is None:
                 file_id = generate_ids.gen_file_id(f)
-            stat = os.lstat(self.abspath(f))
-            sha1 = '1' * 20 # FIXME: DIRSTATE MERGE BLOCKER
-            state.add(f, file_id, kind, stat, sha1)
+            # deliberately add the file with no cached stat or sha1
+            # - on the first access it will be gathered, and we can
+            # always change this once tests are all passing.
+            state.add(f, file_id, kind, None, '')
         self._dirty = True
 
     def current_dirstate(self):

